varying highp vec2 textureCoordinate;   // vertex传来的纹理坐标

uniform sampler2D vTexture;             //缺省，sampler2D：纹理。

uniform highp float aspectRatio;

uniform mat4 matrix_Center;
uniform highp vec2 center1;
uniform highp vec2 center2;

uniform highp float radius;
uniform highp float scale;





void main()
{
    highp vec2 center10 =( matrix_Center * vec4(center1,0,1) ).xy ;
    highp vec2 center20 =( matrix_Center * vec4(center2,0,1) ).xy ;

    highp vec2 textureCoordinateToUse = vec2(textureCoordinate.x, (textureCoordinate.y * aspectRatio + 0.5 - 0.5 * aspectRatio));

    highp float dist1 = distance(center10, textureCoordinateToUse);
    highp float dist2 = distance(center20, textureCoordinateToUse);

    textureCoordinateToUse = textureCoordinate;

    if (dist1 < radius )
    {
        textureCoordinateToUse -= center10;
        highp float percent = 1.0 - ((radius - dist1) / radius) * scale;
        percent = percent * percent;
        textureCoordinateToUse = textureCoordinateToUse * percent;
        textureCoordinateToUse += center10;
    }else if( dist2 < radius )
    {
        textureCoordinateToUse -= center20;
        highp float percent = 1.0 - ((radius - dist2) / radius) * scale;
        percent = percent * percent;
        textureCoordinateToUse = textureCoordinateToUse * percent;
        textureCoordinateToUse += center20;
    }

    gl_FragColor = texture2D(vTexture, textureCoordinateToUse );
}



