varying highp vec2 textureCoordinate;   // vertex传来的纹理坐标

uniform sampler2D vTexture;             //缺省，sampler2D：纹理。

uniform highp float aspectRatio;
uniform mat4 matrix_Center;             //原地y翻转：先y翻转在向下平移1（纹理高）

uniform highp int infos_Num ; //特征点数
uniform highp float infos[200]; //特征点



void main(){

    highp vec2 point;
    highp vec2 pointToUse;
    highp float dist;
    vec4 color = texture2D(vTexture, textureCoordinate );//原始

    highp vec2 textureCoordinateToUse = vec2(textureCoordinate.x, (textureCoordinate.y * aspectRatio + 0.5 - 0.5 * aspectRatio));

     for(int i = 0; i < infos_Num; i++)
     {
        point =( matrix_Center * vec4(vec2(infos[i * 2], infos[i * 2 + 1]),0,1) ).xy ; //原特征点纹理向下（左上原点），改与本滤镜纹理方向一致：向上（左下原点）

        pointToUse = vec2(point.x, (point.y * aspectRatio + 0.5 - 0.5 * aspectRatio));

        //纹理坐标(0,1),是压缩长边，还原宽高比图像计算距离更准确
        dist = distance(pointToUse, textureCoordinateToUse);

        if (dist < 0.02f){
            color = vec4(1.0, 0, 0, 1.0); //红色
        }
     }


    gl_FragColor = color;

}



